{ Invokable implementation File for TServiceArq which implements IServiceArq }

unit ServiceArqImpl;

interface

uses InvokeRegistry, Types, XSBuiltIns, ServiceArqIntf, SysUtils,Classes;

type
  { TServiceArq }
  TServiceArq = class(TInvokableClass, IServiceArq)
  public
    function getArquivo(const ANome: WideString):TSOAPAttachment; stdcall;
    function EnviaArquivo(const ANome: WideString;const AArquivo:TSOAPAttachment):boolean; stdcall;
    function getListaArquivos : ArrayofString; stdcall;
  end;

  function GetDataDir: string;

implementation


function GetDataDir: string;
// retorna a pasta para onde deve ser armazenado o arquivo
begin
  Result := ExtractFilePath(ParamSTr(0))+'Data\';
  // declarar SysUtils
end;


{ TServiceArq }

function TServiceArq.EnviaArquivo(const ANome: WideString;
  const AArquivo: TSOAPAttachment): boolean;
// mtodo para fazer o upload pelo cliente
begin
  AArquivo.SaveToFile(GetDataDir + ANome);
  Result := True;
end;

function TServiceArq.getArquivo(const ANome: WideString): TSOAPAttachment;
// mtodo para fazer o download no cliente
begin
  Result := TSoapAttachment.Create;
  Result.SetSourceFile(GetDataDir + ANome);
end;

function TServiceArq.getListaArquivos: ArrayofString;
// retorna a lista de arquivos da pasta do ws
var
  sr       : TSearchRec;
  templist : TStrings; // declarar Classes
  i        : integer;
  Path     : string;
begin
  templist := TStringlist.create;
  try
    Path := GetDataDir;
    if DirectoryExists(Path) then
    Begin
      if FindFirst(Path + '*.*', faReadOnly+faHidden+faSysFile, sr) = 0 then
      begin
        templist.add(sr.name);
        while FindNext(sr) = 0 do
          templist.add(sr.name);
        FindClose(sr);
      end;
      //
      SetLength(Result, templist.Count);
      for i := 0 to templist.Count-1 do
      Begin
        Result[i]:=templist[i];
      End;
    End;
  finally
    tempList.Free;
  end;
end;

initialization
{ Invokable classes must be registered }
   InvRegistry.RegisterInvokableClass(TServiceArq);
end.

